Properties Methods Events Config Options Direct Link

    Observable
      Provider
        JsonProvider
          RemotingProvider

# Class Ext.direct.RemotingProvider

Package: | Ext.direct
Defined In: | RemotingProvider.js
Class: | RemotingProvider
Extends: | JsonProvider

The RemotingProvider exposes access to server side methods on the client (a remote procedure call (RPC) type of connection where the client can initiate a procedure on the server).

This allows for code to be organized in a fashion that is maintainable, while providing a clear path between client and server, something that is not always apparent when using URLs.

To accomplish this the server-side needs to describe what classes and methods are available on the client-side. This configuration will typically be outputted by the server-side Ext.Direct stack when the API description is built.

## Config Options

Config Options | Defined By
--- | ---

actions : Object
Object literal defining the server side actions and methods. For example, if the Provider is configured with: "action...
Object literal defining the server side actions and methods. For example, if the Provider is configured with:

    "actions":{ // each property within the 'actions' object represents a server side Class
        "TestAction":[ // array of methods within each server side Class to be
        {              // stubbed out on client
            "name":"doEcho",
            "len":1
        },{
            "name":"multiply",// name of method
            "len":2           // The number of parameters that will be used to create an
                              // array of data to send to the server side function.
                              // Ensure the server sends back a Number, not a String.
        },{
            "name":"doForm",
            "formHandler":true, // direct the client to use specialized form handling method
            "len":1
        }]
    }

Note that a Store is not required, a server method can be called at any time. In the following example a client side handler is used to call the server side method "multiply" in the server-side "TestAction" Class:

    TestAction.multiply(
        2, 4, // pass two arguments to server, so specify len=2
        // callback function after the server is called
        // result: the result returned by the server
        //      e: Ext.Direct.RemotingEvent object
        function(result, e){
            var t = e.getTransaction();
            var action = t.action; // server side Class called
            var method = t.method; // server side method called
            if(e.status){
                var answer = Ext.encode(result); // 8

            }else{
                var msg = e.message; // failure message
            }
        }
    );

In the example above, the server side "multiply" function will be passed two arguments (2 and 4). The "multiply" method should return the value 8 which will be available as the `result` in the example above.

RemotingProvider

enableBuffer : Number/Boolean
true or false to enable or disable combining of method calls. If a number is specified this is the amount of time in ...

`true` or `false` to enable or disable combining of method calls. If a number is specified this is the amount of time in milliseconds to wait before sending a batched request (defaults to `10`).

Calls which are received within the specified timeframe will be concatenated together and sent in a single request, optimizing the application by reducing the amount of round trips that have to be made to the server.

RemotingProvider

| enableUrlEncode : String Specify which param will hold the arguments for the method. Defaults to `'data'`. | RemotingProvider

id : String
The unique id of the provider (defaults to an auto-assigned id). You should assign an id if you need to be able to ac...
The unique id of the provider (defaults to an auto-assigned id). You should assign an id if you need to be able to access the provider later and you do not have an object reference available, for example:

    Ext.Direct.addProvider(
        {
            type: 'polling',
            url:  'php/poll.php',
            id:   'poll-provider'
        }
    );

    var p = Ext.Direct.getProvider('poll-provider');
    p.disconnect();

Provider

listeners : Object
A config object containing one or more event handlers to be added to this object during initialization. This should ...

A config object containing one or more event handlers to be added to this object during initialization. This should be a valid listeners config object as specified in the addListener example for attaching multiple handlers at once.

DOM events from ExtJs Components

While some ExtJs Component classes export selected DOM events (e.g. "click", "mouseover" etc), this is usually only done when extra value can be added. For example the DataView's `click` event passing the node clicked on. To access DOM events directly from a Component's HTMLElement, listeners must be added to the Element after the Component has been rendered. A plugin can simplify this step:

    // Plugin is configured with a listeners config object.
    // The Component is appended to the argument list of all handler functions.
    Ext.DomObserver = Ext.extend(Object, {
        constructor: function(config) {
            this.listeners = config.listeners ? config.listeners : config;
        },

        // Component passes itself into plugin's init method
        init: function(c) {
            var p, l = this.listeners;
            for (p in l) {
                if (Ext.isFunction(l[p])) {
                    l[p] = this.createHandler(l[p], c);
                } else {
                    l[p].fn = this.createHandler(l[p].fn, c);
                }
            }

            // Add the listeners to the Element immediately following the render call
            c.render = c.render.createSequence(function() {
                var e = c.getEl();
                if (e) {
                    e.on(l);
                }
            });
        },

        createHandler: function(fn, c) {
            return function(e) {
                fn.call(this, e, c);
            };
        }
    });

    var combo = new Ext.form.ComboBox({

        // Collapse combo when its element is clicked on
        plugins: [ new Ext.DomObserver({
            click: function(evt, comp) {
                comp.collapse();
            }
        })],
        store: myStore,
        typeAhead: true,
        mode: 'local',
        triggerAction: 'all'
    });

Observable

| maxRetries : Number Number of times to re-attempt delivery on failure of a call. Defaults to `1`. | RemotingProvider
| namespace : String/Object Namespace for the Remoting Provider (defaults to the browser global scope of window). Explicitly specify the namespac... Namespace for the Remoting Provider (defaults to the browser global scope of window). Explicitly specify the namespace Object, or specify a String to have a namespace created implicitly. | RemotingProvider
| priority : Number Priority of the request. Lower is higher priority, 0 means "duplex" (always on). All Providers default to 1 except fo... Priority of the request. Lower is higher priority, `0` means "duplex" (always on). All Providers default to `1` except for PollingProvider which defaults to `3`. | Provider
| timeout : Number The timeout to use for each request. Defaults to `undefined`. | RemotingProvider

type : String
Required, undefined by default. The type of provider specified to Ext.Direct.addProvider to create a new Provider. A...
Required, `undefined` by default. The `type` of provider specified to Ext.Direct.addProvider to create a new Provider. Acceptable values by default are:

- `polling` : PollingProvider
- `remoting` : RemotingProvider

Provider

| url : String Required. The url to connect to the Ext.Direct server-side router. | RemotingProvider

## Public Properties

Property | Defined By
--- | ---
| connect : Object Abstract methods for subclasses to implement. | Provider
| disconnect : Object Abstract methods for subclasses to implement. | Provider

## Public Methods

Method | Defined By
--- | ---

addEvents( `Object|String o`, `string Optional.` ) : void
Adds the specified events to the list of events which this Observable may fire.
Adds the specified events to the list of events which this Observable may fire.
Parameters:

- `o` : Object|String
  Either an object with event names as properties with a value of `true` or the first event name string if multiple event names are being passed as separate parameters.
- `Optional.` : string
  Event name if multiple event names are being passed as separate parameters. Usage:

      this.addEvents('storeloaded', 'storecleared');

Returns:

- void

Observable

addListener( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object.
Appends an event handler to this object.
Parameters:

- `eventName` : String
  The name of the event to listen for.
- `handler` : Function
  The method the event invokes.
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration. properties. This may contain any of the following properties:
  - scope : Object
    The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
  - delay : Number
    The number of milliseconds to delay the invocation of the handler after the event fires.
  - single : Boolean
    True to add a handler to handle just the next firing of the event, and then remove itself.
  - buffer : Number
    Causes the handler to be scheduled to run in an Ext.util.DelayedTask delayed by the specified number of milliseconds. If the event fires again within that time, the original handler is not invoked, but the new handler is scheduled in its place.
  - target : Observable
    Only call the handler if the event was fired on the target Observable, not if the event was bubbled up from a child Observable.

  Combining Options
  Using the options argument, it is possible to combine different types of listeners:
  A delayed, one-time listener.

      myDataView.on('click', this.onClick, this, {
      single: true,
      delay: 100
      });

  Attaching multiple handlers in 1 call
  The method also allows for a single argument to be passed which is a config object containing properties which specify multiple handlers.

      myGridPanel.on({
      'click' : {
          fn: this.onClick,
          scope: this,
          delay: 100
      },
      'mouseover' : {
          fn: this.onMouseOver,
          scope: this
      },
      'mouseout' : {
          fn: this.onMouseOut,
          scope: this
      }
      });

  Or a shorthand syntax:

      myGridPanel.on({
      'click' : this.onClick,
      'mouseover' : this.onMouseOver,
      'mouseout' : this.onMouseOut,
       scope: this
      });

Returns:

- void

Observable

enableBubble( `String/Array events` ) : void
Enables events fired by this Observable to bubble up an owner hierarchy by calling this.getBubbleTarget() if present....

Enables events fired by this Observable to bubble up an owner hierarchy by calling `this.getBubbleTarget()` if present. There is no implementation in the Observable base class.

This is commonly used by Ext.Components to bubble events to owner Containers. See Ext.Component.getBubbleTarget. The default implementation in Ext.Component returns the Component's immediate owner. But if a known target is required, this can be overridden to access the required target more quickly.

Example:

    Ext.override(Ext.form.Field, {
        //  Add functionality to Field's initComponent to enable the change event to bubble
        initComponent : Ext.form.Field.prototype.initComponent.createSequence(function() {
            this.enableBubble('change');
        }),

        //  We know that we want Field's events to bubble directly to the FormPanel.
        getBubbleTarget : function() {
            if (!this.formPanel) {
                this.formPanel = this.findParentByType('form');
            }
            return this.formPanel;
        }
    });

    var myForm = new Ext.formPanel({
        title: 'User Details',
        items: [{
            ...
        }],
        listeners: {
            change: function() {
                // Title goes red if form has been modified.
                myForm.header.setStyle('color', 'red');
            }
        }
    });

Parameters:

- `events` : String/Array
  The event name to bubble, or an Array of event names.

Returns:

- void

Observable

fireEvent( `String eventName`, `Object... args` ) : Boolean
Fires the specified event with the passed parameters (minus the event name). An event may be set to bubble up an Obse...

Fires the specified event with the passed parameters (minus the event name).

An event may be set to bubble up an Observable parent hierarchy (See Ext.Component.getBubbleTarget) by calling enableBubble.

Parameters:

- `eventName` : String
  The name of the event to fire.
- `args` : Object...
  Variable number of parameters are passed to handlers.

Returns:

- `Boolean`
  returns false if any of the handlers return false otherwise it returns true.

Observable

hasListener( `String eventName` ) : Boolean
Checks to see if this object has any listeners for a specified event
Checks to see if this object has any listeners for a specified event
Parameters:

- `eventName` : String
  The name of the event to check for

Returns:

- `Boolean`
  True if the event is being listened for, else false

Observable

isConnected() : void
Returns whether or not the server-side is currently connected. Abstract method for subclasses to implement.
Returns whether or not the server-side is currently connected. Abstract method for subclasses to implement.
Parameters:

- None.

Returns:

- void

Provider

on( `String eventName`, `Function handler`, [`Object scope`], [`Object options`] ) : void
Appends an event handler to this object (shorthand for addListener.)
Appends an event handler to this object (shorthand for addListener.)
Parameters:

- `eventName` : String
  The type of event to listen for
- `handler` : Function
  The method the event invokes
- `scope` : Object
  (optional) The scope (`this` reference) in which the handler function is executed. If omitted, defaults to the object which fired the event.
- `options` : Object
  (optional) An object containing handler configuration.

Returns:

- void

Observable

purgeListeners() : void
Removes all listeners for this object
Removes all listeners for this object
Parameters:

- None.

Returns:

- void

Observable

relayEvents( `Object o`, `Array events` ) : void
Relays selected events from the specified Observable as if the events were fired by this.
Relays selected events from the specified Observable as if the events were fired by `this`.
Parameters:

- `o` : Object
  The Observable whose events this object is to relay.
- `events` : Array
  Array of event names to relay.

Returns:

- void

Observable

removeListener( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler.
Removes an event handler.
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

resumeEvents() : void
Resume firing events. (see suspendEvents) If events were suspended using the queueSuspended parameter, then all event...
Resume firing events. (see suspendEvents) If events were suspended using the `queueSuspended` parameter, then all events fired during event suspension will be sent to any listeners now.
Parameters:

- None.

Returns:

- void

Observable

suspendEvents( `Boolean queueSuspended` ) : void
Suspend the firing of all events. (see resumeEvents)
Suspend the firing of all events. (see resumeEvents)
Parameters:

- `queueSuspended` : Boolean
  Pass as true to queue up suspended events to be fired after the resumeEvents call instead of discarding all suspended events;

Returns:

- void

Observable

un( `String eventName`, `Function handler`, [`Object scope`] ) : void
Removes an event handler (shorthand for removeListener.)
Removes an event handler (shorthand for removeListener.)
Parameters:

- `eventName` : String
  The type of event the handler was associated with.
- `handler` : Function
  The handler to remove. This must be a reference to the function passed into the addListener call.
- `scope` : Object
  (optional) The scope originally specified for the handler.

Returns:

- void

Observable

## Public Events

Event | Defined By
--- | ---

beforecall : ( `Ext.direct.RemotingProvider provider`, `Ext.Direct.Transaction transaction` )
Fires immediately before the client-side sends off the RPC call. By returning false from an event handler you can pre...
Fires immediately before the client-side sends off the RPC call. By returning false from an event handler you can prevent the call from executing.
Listeners will be called with the following arguments:

- `provider` : Ext.direct.RemotingProvider
- `transaction` : Ext.Direct.Transaction

RemotingProvider

call : ( `Ext.direct.RemotingProvider provider`, `Ext.Direct.Transaction transaction` )
Fires immediately after the request to the server-side is sent. This does NOT fire after the response has come back f...
Fires immediately after the request to the server-side is sent. This does NOT fire after the response has come back from the call.
Listeners will be called with the following arguments:

- `provider` : Ext.direct.RemotingProvider
- `transaction` : Ext.Direct.Transaction

RemotingProvider

connect : ( `Ext.direct.Provider provider` )
Fires when the Provider connects to the server-side
Fires when the Provider connects to the server-side
Listeners will be called with the following arguments:

- `provider` : Ext.direct.Provider
  The Provider.

Provider

data : ( `Ext.direct.Provider provider`, `event e` )
Fires when the Provider receives data from the server-side
Fires when the Provider receives data from the server-side
Listeners will be called with the following arguments:

- `provider` : Ext.direct.Provider
  The Provider.
- `e` : event
  The Ext.Direct.Event type that occurred.

Provider

disconnect : ( `Ext.direct.Provider provider` )
Fires when the Provider disconnects from the server-side
Fires when the Provider disconnects from the server-side
Listeners will be called with the following arguments:

- `provider` : Ext.direct.Provider
  The Provider.

Provider

exception : ()
Fires when the Provider receives an exception from the server-side
Fires when the Provider receives an exception from the server-side
Listeners will be called with the following arguments:

- None.

Provider